#include "arvbusca.h"

void Inicializa_Arvore(ARVOREB **ab)
{
     *ab = NULL;
}



void EmOrdem(ARVOREB *ab)
{
     if (ab !=NULL)
     {
        EmOrdem(ab->esq);
        printf(" %d ", ab->info); 
        EmOrdem(ab->dir);
     }
}    

void Insere_Elem(ARVOREB **ab, int elem)
{
    if (*ab==NULL)
    {
      *ab = (ARVOREB*)malloc(sizeof(ARVOREB));
     (*ab)->esq = NULL;
     (*ab)->dir = NULL;
     (*ab)->info = elem;
     }
     else {
            if (elem < (*ab)->info)
               Insere_Elem(&(*ab)->esq,elem);
            else Insere_Elem(&(*ab)->dir,elem);
          }
}

ARVOREB *Busca_Elemv(ARVOREB **ab, int elem)
{
       if(*ab == NULL)
         return(NULL);
       else 
          if (elem == (*ab)->info)
              return (*ab);
          else 
             if ( elem < (*ab)->info)
                 return (Busca_Elemv(&(*ab)->esq, elem));
             else 
                 return (Busca_Elemv(&(*ab)->dir, elem));
            
}


ARVOREB *Busca_Elem(ARVOREB *ab, int elem)
{
      ARVOREB *aux;
       if(ab == NULL)
         return(NULL);
       else 
          if (elem == ab->info)
              return (ab);
              
          
          else 
             if ( elem < ab->info)
                 {
                    aux = Busca_Elem(ab->esq, elem);
                    printf("\n aux esq: %p", aux);
                    return aux;
                    // return (Busca_Elem(ab->esq, elem) );
                  }
             else {
                      aux = Busca_Elem(ab->dir, elem);
                      printf("\n aux dir: %p", aux);
                      return aux;
                      // return (Busca_Elem(ab->dir, elem) );
                  }
            
}


ARVOREB *Busca_Elem_Pai(ARVOREB *ab, int elem, ARVOREB **pai)
{
      ARVOREB *aux;
       if(ab == NULL)
         return(NULL);
       else 
          if (elem == ab->info)
              return (ab);
              
          
          else 
             if ( elem < ab->info)
                 {
                    *pai= ab;
                    aux = Busca_Elem_Pai(ab->esq, elem, pai);
                    printf("\n aux esq: %p", aux);
                    return aux;
                    // return (Busca_Elem(ab->esq, elem) );
                  }
             else {
                      *pai= ab;
                      aux = Busca_Elem_Pai(ab->dir, elem, pai);
                      printf("\n aux dir: %p", aux);
                      return aux;
                      // return (Busca_Elem(ab->dir, elem) );
                  }
            
}

int Remove_Elem(ARVOREB **ab, int elem)
{
    ARVOREB *aux, *apmenor, **ppai;
    ARVOREB *pai = NULL;
    aux = Busca_Elem_Pai(*ab, elem, &pai);
    if (aux == NULL)
        return 0;
    
    printf("\n aux = %p, elem em auxu = %d", aux, aux->info);
    //printf("pai de aux= %p, pai-esq = %p, pai-dir = %p", pai, pai->esq, pai->dir);
    getchar();
    if (pai == NULL) //elem esta na raiz
        ppai = ab;   
    else { if (pai->dir == aux)
            {
                         printf("entrou a direita");
                         ppai = &(pai->dir); 
            }
            else ppai = &(pai->esq);
          }
    printf("\n conteudo de ppai = %d", (*ppai)->info);
    if (aux->dir == NULL) //aux tem 0 ou 1 filho a esquerda
    {
        printf("\n ramo a direita eh null");
        *ppai = aux->esq; 
        printf("\nfilho esq -- ppai esq= %p", *ppai);
        free(aux);
    }
    else if (aux->esq ==NULL) // aux tem 0ou 1 filho
         {
             (*ppai) = aux->dir;
              printf("\nfilho dir -- ppai dir= %p, *ppai->info", *ppai, (*ppai)->info);
              free(aux);
         }
         else // aux tem dois filhos
                 {
                     printf("\n aux tem dois filhos");
                     printf("aux->dir = %p, aux->info = %d", aux->dir, aux->info);
                     apmenor=aux->dir;
                     pai=aux; 
                     while (apmenor->esq !=NULL)
                      {
                         pai=apmenor; 
                         apmenor=apmenor->esq;
                      }
                      if (aux == pai)
                      {
                          aux->info = apmenor->info;
                          pai->dir = apmenor->dir;
                      }
                      else
                      {
                         aux->info = apmenor->info;
                         pai->esq = apmenor->dir;
                      }
                      free(apmenor);
                 } 

}

boolean Remove (ARVOREB **p, int x)
{
ARVOREB *aux,*pai,*apmaior;
if (*p==NULL) return FALSE; /*no encontrou chave */
if (x<(*p)->info) return Remove (&((*p)->esq),x);
if (x>(*p)->info) return Remove (&((*p)->dir),x);
/* encontrou chave */
aux=*p;
if ((aux->dir)==NULL)
/*no tem filho dir, substitui por filho esq */
*p=aux->esq;
else
if (aux->esq==NULL)
/*no tem filho esq, substitui por filho dir */
*p=aux->dir;
else /* tem 2 filhos */
{
     /* encontra maior chave  esquerda do n removido */
apmaior=aux->esq;
pai=aux; /* 1 */
while (apmaior->dir) {
pai=apmaior; apmaior=apmaior->dir;
} /* 2 */
aux->info=apmaior->info; /* 3 */
if (pai==aux) pai->esq=apmaior->esq;
else pai->dir=apmaior->esq; /* 4 */
aux=apmaior; /* 5 */
} /*else */
free(aux); /* 6 */
return TRUE;
}

