#include "tree.h"
void Inicializa(ARVORE **ab)
{
     *ab = NULL;
}

void CriarRaiz(ARVORE **ab, char item)
{
       ARVORE *pt;
       pt = (ARVORE*) malloc (sizeof(struct tree));
       pt->info = item;
       pt->esq = NULL;
       pt->dir = NULL;
       *ab = pt;
       return;
}

int Vazia(ARVORE *ab)
{
    if (ab == NULL)
      return 1;
    else return 0;
}

int InserirFilhoaDireita(ARVORE *pai, char item)
{
    ARVORE *pt;
    if (pai->dir != NULL)
       return 0;
    pt =  (ARVORE*) malloc (sizeof(struct tree));
    if (pt == NULL)
        return 0;
    pt->info = item;
    pt->esq = NULL;
    pt->dir = NULL;
    pai->dir = pt;
    return 1;
}

int InserirFilhoaEsquerda(ARVORE *pai, char item)
{
    ARVORE*pt;
    if (pai->esq != NULL)
       return 0;
    pt =  (ARVORE*) malloc (sizeof(struct tree));
    if (pt == NULL)
        return 0;
    pt->info = item;
    pt->esq = NULL;
    pt->dir = NULL;
    pai->esq = pt;
    return 1;
}

void PosOrdem(ARVORE *ab)
{
     if (ab!= NULL)
     {
        PosOrdem(ab->esq);
        PosOrdem(ab->dir);
        printf(" %c ", ab->info); 
     }
      
}

void EmOrdem(ARVORE *ab)
{
     if (ab !=NULL)
     {
        EmOrdem(ab->esq);
        printf(" %c ", ab->info); 
        EmOrdem(ab->dir);
     }
}    
void PreOrdem(ARVORE *ab)
{
     if (ab !=NULL)
     {
            printf(" %c ", ab->info); 
            PreOrdem(ab->esq);
            PreOrdem(ab->dir);
            }
            
}

ARVORE* Esvaziar(ARVORE *ab)
{
    if (ab!=NULL)
    {
       Esvaziar(ab->esq); /* libera sae */
       Esvaziar(ab->dir); /* libera sad */
       free(ab); /* libera raiz */
    }
   return NULL;
}

int Pertence (ARVORE* ab, char item)
{
  if (Vazia(ab))
   return 0; /* rvore vazia: no encontrou */
  else
     return ab->info==item ||
     Pertence(ab->esq,item) ||
     Pertence(ab->dir,item);
}

void Busca(ARVORE *ab, char item, ARVORE **pt)
{
       
    
       if (ab == NULL || *pt != NULL)
         return;
       if (ab->info != item  )
             {
               Busca(ab->esq, item, pt);
               Busca(ab->dir, item, pt);
             }
       else 
            *pt = ab;
                 
       return;
           
}
                     
