

struct tree{
             char info;
             struct tree *esq;
             struct tree *dir;
             };
             
typedef struct tree ARVORE;

void Inicializa(ARVORE **ab);
void CriarRaiz(ARVORE **ab, char item); //retorna o no raiz cirado em arvore
int Vazia(ARVORE *ab); // Funo que retorna TRUE se a rvore est vazia e FALSE do contrrio;
int InserirFilhoaDireita(ARVORE *pai,char item); // Insere o elemento item na rvore  direita do n pai se ele no possui um filho  direita;
int InserirFilhoaEsquerda(ARVORE *pai,char item); // Insere o elemento item na rvore  esquerda do n pai
void Busca(ARVORE *ab, char item, ARVORE **pt); // retorna o ponteiro pont para o n item em Arvore; se item no existe retorna NULL
void PosOrdem(ARVORE *ab);//  percorre em ps-ordem;
void PreOrdem(ARVORE *ab);// percorre em pr-ordem;
void EmOrdem(ARVORE *ab);// percorre ns em ordem;
ARVORE* Esvaziar(ARVORE *ab); // libera todo o espao de memria alocado pela rvore, tornando-a vazia
int Pertence (ARVORE* ab, char item); //verfica se um caracter pertence a arvore
